## libstreamvbyte 0.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)
set(CMAKE_MACOSX_RPATH OFF)
if (NOT CMAKE_BUILD_TYPE)
                message(STATUS "No build type selected, default to Release")
                set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
endif()

project(STREAMVBYTE VERSION "0.0.1")
cmake_policy(SET CMP0065 OLD)
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -v" )
set(BASE_FLAGS
  "-std=c99"
  "-fPIC"
  "-Wextra"
  "-pedantic"
  "-Wshadow"
)
if(CMAKE_BUILD_TYPE MATCHES Debug)
  set(BASE_FLAGS
    ${BASE_FLAGS}
    "-O0"
    "-ggdb"
    )
else()
  set(BASE_FLAGS
    ${BASE_FLAGS}
    "-O3"
    "-g"
    )
endif()
# test for arm
if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64.*|AARCH64.*)")
   set(BASE_FLAGS
    ${BASE_FLAGS}
    "-D__ARM_NEON__"
    )
endif()
set(STREAMVBYTE_SRCS
  ${PROJECT_SOURCE_DIR}/src/streamvbyte_encode.c
  ${PROJECT_SOURCE_DIR}/src/streamvbyte_decode.c
  ${PROJECT_SOURCE_DIR}/src/streamvbyte_zigzag.c
  ${PROJECT_SOURCE_DIR}/src/streamvbytedelta_encode.c
  ${PROJECT_SOURCE_DIR}/src/streamvbytedelta_decode.c
  ${PROJECT_SOURCE_DIR}/src/streamvbyte_0124_encode.c
  ${PROJECT_SOURCE_DIR}/src/streamvbyte_0124_decode.c
   )
add_library(streamvbyte_static STATIC "${STREAMVBYTE_SRCS}")
target_link_libraries(streamvbyte_static ${BASE_FLAGS})
add_library(streamvbyte SHARED "${STREAMVBYTE_SRCS}")
target_link_libraries(streamvbyte ${BASE_FLAGS})
target_include_directories(
  streamvbyte
  PUBLIC ${PROJECT_SOURCE_DIR}/include
)
target_include_directories(
  streamvbyte_static
  PUBLIC ${PROJECT_SOURCE_DIR}/include
)
install(FILES
  ${PROJECT_SOURCE_DIR}/include/streamvbyte.h
  ${PROJECT_SOURCE_DIR}/include/streamvbytedelta.h
  ${PROJECT_SOURCE_DIR}/include/streamvbyte_zigzag.h
   DESTINATION include
  )
install(
  TARGETS streamvbyte streamvbyte_static
  DESTINATION lib)
## -march=native is not supported on some platforms
if(NOT MSVC)
if(NOT STREAMVBYTE_DISABLE_NATIVE)
set(OPT_FLAGS "-march=native")
endif()
endif()

set(CMAKE_C_FLAGS "${STD_FLAGS} ${OPT_FLAGS} ${INCLUDE_FLAGS} ${WARNING_FLAGS} ${SANITIZE_FLAGS} ")

MESSAGE( STATUS "CMAKE_SYSTEM_PROCESSOR: " ${CMAKE_SYSTEM_PROCESSOR})
MESSAGE( STATUS "CMAKE_BUILD_TYPE: " ${CMAKE_BUILD_TYPE} ) # this tends to be "sticky" so you can remain unknowingly in debug mode
MESSAGE( STATUS "CMAKE_C_COMPILER: " ${CMAKE_C_COMPILER} ) # important to know which compiler is used
MESSAGE( STATUS "CMAKE_C_FLAGS: " ${CMAKE_C_FLAGS} ) # important to know the flags
MESSAGE( STATUS "CMAKE_C_FLAGS_DEBUG: " ${CMAKE_C_FLAGS_DEBUG} )
MESSAGE( STATUS "CMAKE_C_FLAGS_RELEASE: " ${CMAKE_C_FLAGS_RELEASE} )

# build programs

# example
add_executable (example ${PROJECT_SOURCE_DIR}/example.c)
target_link_libraries (example streamvbyte_static)
# perf
add_executable (perf ${PROJECT_SOURCE_DIR}/tests/perf.c)
target_link_libraries (perf streamvbyte_static)
target_link_libraries(perf m)
# writeseq
add_executable (writeseq ${PROJECT_SOURCE_DIR}/tests/writeseq.c)
target_link_libraries (writeseq streamvbyte_static)
# unit
add_executable (unit ${PROJECT_SOURCE_DIR}/tests/unit.c)
target_link_libraries (unit streamvbyte_static)

option(STREAMVBYTE_ENABLE_TESTS "enable unit tests for streamvbyte" ON)
if(STREAMVBYTE_ENABLE_TESTS)
    enable_testing()
    # add unit tests
    add_test(NAME unit COMMAND unit)
    add_custom_target(check
        COMMAND ctest --output-on-failure
    DEPENDS unit)
endif()

=== Makefile ===
# minimalist makefile
.SUFFIXES:
#
.SUFFIXES: .cpp .o .c .h

PROCESSOR:=$(shell uname -m)

ifeq ($(PROCESSOR), aarch64)
# for 64-bit ARM processors
CFLAGS = -fPIC -std=c99 -O3 -Wall -Wextra -pedantic -Wshadow -D__ARM_NEON__
else ifeq ($(PROCESSOR), armv7l)
# for 32-bit ARM processors
CFLAGS = -fPIC -std=c99 -O3 -Wall -Wextra -pedantic -Wshadow
else
# Here we expect x64
# Formally speaking, we only need SSE4, at best, but code checks for AVX
# since MSVC only allows to check for AVX and nothing finer like just SSE4
CFLAGS = -fPIC -march=native -std=c99 -O3 -Wall -Wextra -pedantic -Wshadow
endif
LDFLAGS = -shared
LIBNAME=libstreamvbyte.so.0.0.1
LNLIBNAME=libstreamvbyte.so
all:  unit $(LIBNAME)
test:
	./unit
dyntest:   dynunit $(LNLIBNAME)
	LD_LIBRARY_PATH=. ./dynunit

install: $(OBJECTS) $(LIBNAME)
	cp $(LIBNAME) /usr/local/lib
	ln -f -s /usr/local/lib/$(LIBNAME) /usr/local/lib/libstreamvbyte.so
	ldconfig
	cp $(HEADERS) /usr/local/include



HEADERS=./include/streamvbyte.h ./include/streamvbytedelta.h ./include/streamvbyte_zigzag.h

uninstall:
	for h in $(HEADERS) ; do rm  /usr/local/$$h; done
	rm  /usr/local/lib/$(LIBNAME)
	rm /usr/local/lib/libstreamvbyte.so
	ldconfig


OBJECTS= streamvbyte_decode.o streamvbyte_encode.o streamvbytedelta_decode.o streamvbytedelta_encode.o streamvbyte_0124_encode.o  streamvbyte_0124_decode.o streamvbyte_zigzag.o

streamvbyte_zigzag.o: ./src/streamvbyte_zigzag.c $(HEADERS)
	$(CC) $(CFLAGS) -c ./src/streamvbyte_zigzag.c -Iinclude


streamvbytedelta_encode.o: ./src/streamvbytedelta_encode.c $(HEADERS)
	$(CC) $(CFLAGS) -c ./src/streamvbytedelta_encode.c -Iinclude

streamvbytedelta_decode.o: ./src/streamvbytedelta_decode.c $(HEADERS)
	$(CC) $(CFLAGS) -c ./src/streamvbytedelta_decode.c -Iinclude

streamvbyte_0124_encode.o: ./src/streamvbyte_0124_encode.c $(HEADERS)
	$(CC) $(CFLAGS) -c ./src/streamvbyte_0124_encode.c -Iinclude

streamvbyte_0124_decode.o: ./src/streamvbyte_0124_decode.c $(HEADERS)
	$(CC) $(CFLAGS) -c ./src/streamvbyte_0124_decode.c -Iinclude

streamvbyte_decode.o: ./src/streamvbyte_decode.c $(HEADERS)
	$(CC) $(CFLAGS) -c ./src/streamvbyte_decode.c -Iinclude

streamvbyte_encode.o: ./src/streamvbyte_encode.c $(HEADERS)
	$(CC) $(CFLAGS) -c ./src/streamvbyte_encode.c -Iinclude

$(LIBNAME): $(OBJECTS)
	$(CC) $(CFLAGS) -o $(LIBNAME) $(OBJECTS)  $(LDFLAGS)

$(LNLIBNAME): $(LIBNAME)
	ln -f -s $(LIBNAME) $(LNLIBNAME)

shuffle_tables: ./utils/shuffle_tables.c
	$(CC) $(CFLAGS) -o shuffle_tables ./utils/shuffle_tables.c



example: ./example.c    $(HEADERS) $(OBJECTS)
	$(CC) $(CFLAGS) -o example ./example.c -Iinclude  $(OBJECTS)

perf: ./tests/perf.c    $(HEADERS) $(OBJECTS)
	$(CC) $(CFLAGS) -o perf ./tests/perf.c -Iinclude  $(OBJECTS) -lm


writeseq: ./tests/writeseq.c    $(HEADERS) $(OBJECTS)
	$(CC) $(CFLAGS) -o writeseq ./tests/writeseq.c -Iinclude  $(OBJECTS)

unit: ./tests/unit.c    $(HEADERS) $(OBJECTS)
	$(CC) $(CFLAGS) -o unit ./tests/unit.c -Iinclude  $(OBJECTS)

dynunit: ./tests/unit.c    $(HEADERS) $(LIBNAME) $(LNLIBNAME)
	$(CC) $(CFLAGS) -o dynunit ./tests/unit.c -Iinclude  -L. -lstreamvbyte

clean:
	rm -f unit *.o $(LIBNAME) $(LNLIBNAME)  example shuffle_tables perf writeseq dynunit

=== debian/changelog ===
libstreamvbyte (0.4.1-4) unstable; urgency=medium

  * Really fix watch file

 -- Andreas Tille <tille@debian.org>  Thu, 17 Feb 2022 17:00:45 +0100

libstreamvbyte (0.4.1-3) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)
  * Apply multi-arch hints.
    + libstreamvbyte-dev, libstreamvbyte0: Add Multi-Arch: same.

 -- Andreas Tille <tille@debian.org>  Wed, 13 Oct 2021 06:55:01 +0200

libstreamvbyte (0.4.1-2) unstable; urgency=medium

  * d/p/fix-baseline.patch: Remove march=native to fix baseline

 -- Nilesh Patra <nilesh@debian.org>  Thu, 19 Aug 2021 01:05:27 +0530

libstreamvbyte (0.4.1-1) unstable; urgency=medium

  [ Andreas Tille, Nilesh Patra]
  * Initial release (Closes: #963142)

 -- Andreas Tille <tille@debian.org>  Sat, 22 May 2021 23:31:09 +0530

=== debian/control ===
Source: libstreamvbyte
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>, Nilesh Patra <nilesh@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               d-shlibs,
               cmake
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/libstreamvbyte
Vcs-Git: https://salsa.debian.org/med-team/libstreamvbyte.git
Homepage: https://github.com/lemire/streamvbyte
Rules-Requires-Root: no

Package: libstreamvbyte0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Multi-Arch: same
Description: fast integer compression in C using the StreamVByte codec
 StreamVByte is a new integer compression technique that applies SIMD
 instructions (vectorization) to Google's Group Varint approach. The net
 result is faster than other byte-oriented compression techniques.
 .
 It includes fast differential coding.
 .
 It assumes a recent Intel processor (e.g., haswell or better) or an ARM
 processor with NEON instructions (which is almost all of them).

Package: libstreamvbyte-dev
Architecture: any
Section: libdevel
Depends: libstreamvbyte0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Multi-Arch: same
Description: fast integer compression in C using the StreamVByte codec (devel)
 StreamVByte is a new integer compression technique that applies SIMD
 instructions (vectorization) to Google's Group Varint approach. The net
 result is faster than other byte-oriented compression techniques.
 .
 It includes fast differential coding.
 .
 It assumes a recent Intel processor (e.g., haswell or better) or an ARM
 processor with NEON instructions (which is almost all of them).
 .
 This package contains the static library and header files.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk
# this provides:
# DEB_SOURCE: the source package name

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_install:
	dh_install
	mv debian/tmp/usr/lib/$(DEB_SOURCE)_static.a debian/tmp/usr/lib/$(DEB_SOURCE).a
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/include usr \
		    debian/tmp/usr/lib/*.so

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/lemire/streamvbyte/tags .*/v?@ANY_VERSION@\.tar\.gz

## libstreamvbyte 0.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,33 +1,34 @@
 cmake_minimum_required(VERSION 3.3)
 set(CMAKE_MACOSX_RPATH OFF)
+project(STREAMVBYTE VERSION "1.0.0")
+
+set(STREAMVBYTE_LIB_VERSION "1.0.0" CACHE STRING "streamvbyte library version")
+set(STREAMVBYTE_LIB_SOVERSION "1" CACHE STRING "streamvbyte library soversion")
+
+set(CMAKE_C_STANDARD 99)
+set(CMAKE_C_STANDARD_REQUIRED ON)
+option(STREAMVBYTE_SANITIZE "Sanitize addresses" OFF)
 if (NOT CMAKE_BUILD_TYPE)
-                message(STATUS "No build type selected, default to Release")
-                set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
+  message(STATUS "No build type selected")
+  if(STREAMVBYTE_SANITIZE)
+    message(STATUS "Default to Debug")
+    set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
+  else()
+    message(STATUS "Default to Release")
+    set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
+  endif()
 endif()
 
-project(STREAMVBYTE VERSION "0.0.1")
-cmake_policy(SET CMP0065 OLD)
-set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
-set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -v" )
-set(BASE_FLAGS
-  "-std=c99"
-  "-fPIC"
-  "-Wextra"
-  "-pedantic"
-  "-Wshadow"
-)
-if(CMAKE_BUILD_TYPE MATCHES Debug)
-  set(BASE_FLAGS
-    ${BASE_FLAGS}
-    "-O0"
-    "-ggdb"
-    )
-else()
-  set(BASE_FLAGS
-    ${BASE_FLAGS}
-    "-O3"
-    "-g"
-    )
+if(STREAMVBYTE_SANITIZE)
+  message(STATUS "Enabling memory sanitizer.")
+  add_compile_options(-fsanitize=address  -fno-omit-frame-pointer -fno-sanitize-recover=all)
+  add_compile_definitions(ASAN_OPTIONS=detect_leaks=1)
+endif()
+
+if (MSVC)
+    add_definitions(
+        "-D__restrict__=__restrict"
+        )
 endif()
 # test for arm
 if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64.*|AARCH64.*)")
@@ -45,10 +46,25 @@
   ${PROJECT_SOURCE_DIR}/src/streamvbyte_0124_encode.c
   ${PROJECT_SOURCE_DIR}/src/streamvbyte_0124_decode.c
    )
+set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 add_library(streamvbyte_static STATIC "${STREAMVBYTE_SRCS}")
 target_link_libraries(streamvbyte_static ${BASE_FLAGS})
 add_library(streamvbyte SHARED "${STREAMVBYTE_SRCS}")
 target_link_libraries(streamvbyte ${BASE_FLAGS})
+
+set_target_properties(
+    streamvbyte PROPERTIES
+    VERSION "${STREAMVBYTE_LIB_VERSION}"
+    SOVERSION "${STREAMVBYTE_LIB_SOVERSION}"
+    WINDOWS_EXPORT_ALL_SYMBOLS YES
+)
+set_target_properties(
+    streamvbyte_static PROPERTIES
+    VERSION "${STREAMVBYTE_LIB_VERSION}"
+    SOVERSION "${STREAMVBYTE_LIB_SOVERSION}"
+    WINDOWS_EXPORT_ALL_SYMBOLS YES
+)
+
 target_include_directories(
   streamvbyte
   PUBLIC ${PROJECT_SOURCE_DIR}/include
@@ -66,14 +82,13 @@
 install(
   TARGETS streamvbyte streamvbyte_static
   DESTINATION lib)
-## -march=native is not supported on some platforms
-if(NOT MSVC)
-if(NOT STREAMVBYTE_DISABLE_NATIVE)
-set(OPT_FLAGS "-march=native")
+
+
+option(STREAMVBYTE_SANITIZE_UNDEFINED "Sanitize undefined behavior" OFF)
+if(STREAMVBYTE_SANITIZE_UNDEFINED)
+  add_compile_options(-fsanitize=undefined -fno-sanitize-recover=all)
+  add_link_options(-fsanitize=undefined -fno-sanitize-recover=all)
 endif()
-endif()
-
-set(CMAKE_C_FLAGS "${STD_FLAGS} ${OPT_FLAGS} ${INCLUDE_FLAGS} ${WARNING_FLAGS} ${SANITIZE_FLAGS} ")
 
 MESSAGE( STATUS "CMAKE_SYSTEM_PROCESSOR: " ${CMAKE_SYSTEM_PROCESSOR})
 MESSAGE( STATUS "CMAKE_BUILD_TYPE: " ${CMAKE_BUILD_TYPE} ) # this tends to be "sticky" so you can remain unknowingly in debug mode
@@ -87,10 +102,13 @@
 # example
 add_executable (example ${PROJECT_SOURCE_DIR}/example.c)
 target_link_libraries (example streamvbyte_static)
-# perf
-add_executable (perf ${PROJECT_SOURCE_DIR}/tests/perf.c)
-target_link_libraries (perf streamvbyte_static)
-target_link_libraries(perf m)
+
+if(NOT MSVC)
+    # perf
+    add_executable (perf ${PROJECT_SOURCE_DIR}/tests/perf.c)
+    target_link_libraries (perf streamvbyte_static)
+    target_link_libraries(perf m)
+endif()
 # writeseq
 add_executable (writeseq ${PROJECT_SOURCE_DIR}/tests/writeseq.c)
 target_link_libraries (writeseq streamvbyte_static)

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # Here we expect x64
 # Formally speaking, we only need SSE4, at best, but code checks for AVX
 # since MSVC only allows to check for AVX and nothing finer like just SSE4
-CFLAGS = -fPIC -march=native -std=c99 -O3 -Wall -Wextra -pedantic -Wshadow
+CFLAGS = -fPIC -std=c99 -O3 -Wall -Wextra -pedantic -Wshadow
 endif
 LDFLAGS = -shared
 LIBNAME=libstreamvbyte.so.0.0.1

=== debian/changelog ===
libstreamvbyte (0.5.1-2) unstable; urgency=medium

  * Team Upload.
  * Remove myself from uploaders
  * Bump Standards-Version to 4.7.2 (no changes needed)
  * Add patch to fix FTBFS with cmake 4 (Closes: #1113206)

 -- Nilesh Patra <nilesh@debian.org>  Fri, 26 Sep 2025 16:34:55 +0530

libstreamvbyte (0.5.1-1) experimental; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Add symbols
  * Bump SONAME
  * Provide symbols file for amd64 only to reduce maintenance burden

 -- Andreas Tille <tille@debian.org>  Wed, 24 Aug 2022 15:11:46 +0200

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,18 @@
 Source: libstreamvbyte
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>, Nilesh Patra <nilesh@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                d-shlibs,
                cmake
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/libstreamvbyte
 Vcs-Git: https://salsa.debian.org/med-team/libstreamvbyte.git
 Homepage: https://github.com/lemire/streamvbyte
 Rules-Requires-Root: no
 
-Package: libstreamvbyte0
+Package: libstreamvbyte1
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends},
@@ -31,7 +31,7 @@
 Package: libstreamvbyte-dev
 Architecture: any
 Section: libdevel
-Depends: libstreamvbyte0 (= ${binary:Version}),
+Depends: libstreamvbyte1 (= ${binary:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
 Multi-Arch: same
